;
; test.asm
; Bumblebee <bbbee@mailcity.com>
;
; Description:
;
; It shows how to load a plugin (DLL) and exec the provided api. It
; filters non PROVIDE_APP plugins.
;
;
.486p
locals
.model flat,STDCALL

        extrn           ExitProcess:PROC
        extrn          LoadLibraryA:PROC
        extrn        GetProcAddress:PROC
        extrn           FreeLibrary:PROC

include ../inc/plugin.inc

.DATA

; plugin name to load
plugindll       db      'plugin.dll',0

; following data is needed EVER
plugitstr       db      'PlugIt',0              ; get PlugIt API
dllHnd          dd      ?                       ; handle for the DLL
pluginInfo      PluginObject <?>                ; buff to store plugin info

.CODE
inicio:
        push    offset plugindll                ; load the DLL
        call    LoadLibraryA
        or      eax,eax
        jz      pluginNotLoaded
        mov     [dllHnd],eax

        push    offset plugitstr                ; get PlugIt api
        push    eax
        call    GetProcAddress
        or      eax,eax
        jz      pluginNotLoadedFreeDLL

        push    offset pluginInfo               ; get plugin info
        call    eax

                                                ; check it's app
        cmp     pluginInfo.po_provides,PROVIDE_APP
        jne     pluginNotLoadedFreeDLL

        mov     eax,pluginInfo.po_api           ; exec api
        call    eax

pluginNotLoadedFreeDLL:
        push    [dllHnd]
        call    FreeLibrary

pluginNotLoaded:
        push    0h
        call    ExitProcess

Ends
End     inicio


