;
; base64.inc
; Bumblebee <bbbee@mailcity.com>
;
;
BASE64INC=1
; This data is required to encode into Base64 -------------------------------
IFNDEF DBASE64INC       ; it will include once if dbase64.inc is included
BASE64encTable  db      'ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuv'
                db      'wxyz0123456789+/=',0
ENDIF
; The required data to encode into Base64 ends here -------------------------

;
; encodeBase64 by Bumblebee. All rights reserved ;)
; Feel free to modify and distribute this code.
; This version will do padding :D
;
; in:   eax address of data to encode
;       edx address to put encoded data
;       ecx size of data to encode
;
; out:  ecx size of encoded data
;
encodeBase64:
        push    ecx
        pushad

        xor     esi,esi
        lea     edi,BASE64encTable

BASE64baseLoop:
        xor     ebx,ebx
        mov     bl,byte ptr [eax]
        shr     bl,2
        and     bl,00111111b
        mov     bh,byte ptr [edi+ebx]
        mov     byte ptr [edx+esi],bh
        inc     esi

        mov     bx,word ptr [eax]
        xchg    bl,bh
        shr     bx,4
        mov     bh,0
        and     bl,00111111b
        mov     bh,byte ptr [edi+ebx]
        mov     byte ptr [edx+esi],bh
        inc     esi

        inc     eax
        mov     bx,word ptr [eax]
        xchg    bl,bh
        shr     bx,6
        mov     bh,0
        and     bl,00111111b
        mov     bh,byte ptr [edi+ebx]
        mov     byte ptr [edx+esi],bh
        inc     esi

        inc     eax
        xor     ebx,ebx
        mov     bl,byte ptr [eax]
        and     bl,00111111b
        mov     bh,byte ptr [edi+ebx]
        mov     byte ptr [edx+esi],bh
        inc     esi
        inc     eax

        cmp     ecx,3
        jb      BASE64encPad0
        sub     ecx,3
        cmp     ecx,0
        jne     BASE64baseLoop
        jmp     BASE64encDone

BASE64encPad0:
        xor     ebx,ebx
        mov     bl,byte ptr [eax]
        shr     bl,2
        and     bl,00111111b
        mov     bh,byte ptr [edi+ebx]
        mov     byte ptr [edx+esi],bh
        inc     esi

        cmp     ecx,2
        je      BASE64encPad1

        mov     bx,word ptr [eax]
        and     bl,00000011b
        mov     bh,byte ptr [edi+ebx]
        mov     byte ptr [edx+esi],bh
        inc     esi

        mov     ecx,2
        jmp     BASE64encPad3
BASE64encPad1:
        mov     bx,word ptr [eax]
        xchg    bl,bh
        shr     bx,4
        mov     bh,0
        and     bl,00111111b
        mov     bh,byte ptr [edi+ebx]
        mov     byte ptr [edx+esi],bh
        inc     esi

        mov     bx,word ptr [eax]
        xchg    bl,bh
        mov     bh,0
        and     bl,00000011b
        mov     bh,byte ptr [edi+ebx]
        mov     byte ptr [edx+esi],bh
        inc     esi

        mov     ecx,1
BASE64encPad3:
        mov     edi,edx
        add     edi,esi
        mov     al,'='
        add     esi,ecx
        rep     stosb

BASE64encDone:

        mov     dword ptr [esp+20h],esi
        popad
        pop     ecx
        ret

