;
; dbase64.inc
; Bumblebee <bbbee@mailcity.com>
;
;
DBASE64INC=1
; The required data to decode Base64 into binary ----------------------------
IFNDEF BASE64INC        ; it will include once if base64.inc is included
BASE64encTable  db      'ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuv'
                db      'wxyz0123456789+/=',0
ENDIF
; The required data to decode Base64 into binary ends here ------------------

;
; decodeBase64 by Bumblebee. All rights reserved ;)
; Feel free to modify and distribute this code.
; This version will support padding :D
;
; IMPORTANT NOTICE: eax must point to 1st encoded byte, even this algo
; will skip CRLF chars. THIS ALGO IS SLOW, use it carefully.
;
; in:   eax address of data to decode
;       edx address to put decoded data
;
; out:  ecx size of decoded data
;
decodeBase64:
        push    ecx
        pushad

        xor     edi,edi
@dbLoop:
        mov     ecx,4
        xor     esi,esi
        dec     eax
@dbLoopSkipChar:
        inc     eax
@dbGetOct:
        call    DBaseAux
        jc      @dbRightChar
        cmp     byte ptr [eax],0dh
        je      @dbLoopSkipChar
        cmp     byte ptr [eax],0ah
        je      @dbLoopSkipChar
        jmp     @dbEndOfData
@dbRightChar:
        shl     esi,8
        and     ebx,0ffh
        or      esi,ebx
        inc     eax
        loop    @dbGetOct

        mov     ebx,esi
        cmp     bh,65
        je      @dbpad0
        cmp     bl,65
        je      @dbpad1

        call    DBbyteSwap

        shl     bl,2
        and     bh,00110000b
        shr     bh,4
        or      bl,bh
        mov     byte ptr [edx+edi],bl
        inc     edi

        shr     esi,8
        mov     ebx,esi

        and     bl,00001111b
        shl     bl,4
        and     bh,00111100b
        shr     bh,2
        or      bl,bh
        mov     byte ptr [edx+edi],bl
        inc     edi

        shr     esi,8
        mov     ebx,esi

        and     bl,00000011b
        shl     bl,6
        or      bl,bh
        mov     byte ptr [edx+edi],bl
        inc     edi

        jmp     @dbLoop

@dbpad0:
        call    DBbyteSwap

        shl     bl,2
        and     bh,00110000b
        shr     bh,4
        or      bl,bh
        mov     byte ptr [edx+edi],bl
        inc     edi

        shr     esi,8
        mov     ebx,esi

        and     bl,00001111b
        shl     bl,4
        mov     byte ptr [edx+edi],bl
        inc     edi

        jmp     @dbEndOfData

@dbpad1:
        call    DBbyteSwap

        shl     bl,2
        and     bh,00110000b
        shr     bh,4
        or      bl,bh
        mov     byte ptr [edx+edi],bl
        inc     edi

        shr     esi,8
        mov     ebx,esi

        and     bl,00001111b
        shl     bl,4
        and     bh,00111100b
        shr     bh,2
        or      bl,bh
        mov     byte ptr [edx+edi],bl
        inc     edi

        shr     esi,8
        mov     ebx,esi

        and     bl,00000011b
        shl     bl,6
        mov     byte ptr [edx+edi],bl
        inc     edi

@dbEndOfData:
        mov     dword ptr [esp+20h],edi
        popad
        pop     ecx
        ret

DBbyteSwap:
        xchg    bl,bh
        shl     ebx,16
        mov     ecx,esi
        shr     ecx,16
        xchg    cl,ch
        or      ebx,ecx
        mov     esi,ebx
        ret

DBaseAux:
        push    edi
        lea     edi,BASE64encTable
        push    edi
        mov     bl,byte ptr [eax]
@AuxSearchLoop:
        cmp     byte ptr [edi],0
        je      @AuxNotFound
        cmp     byte ptr [edi],bl
        je      @AuxFound
        inc     edi
        jmp     @AuxSearchLoop
@AuxNotFound:
        pop     edi edi
        clc
        ret
@AuxFound:
        pop     ebx
        sub     edi,ebx
        mov     ebx,edi
        pop     edi
        stc
        ret

