;
; BUmblebee's SO SIMple HASH [BUSOSIM-HASH]
;
; That's a simple hash function based on a linear congruential generator
; to avoid the usage of great tables.
;
; It generates a 256 bits number for given data.
;

;
; void hash(DWORD data, DWORD len, DWORD result)
;
hash:
        push    ebp
        mov     ebp,esp
        pushad

        mov     esi,dword ptr [ebp+8]
        mov     ecx,dword ptr [ebp+12]
        mov     edi,dword ptr [ebp+16]

        push    edi ecx
        mov     ecx,32
        xor     eax,eax
        rep     stosb
        pop     ecx edi

        mov     edx,8
hash0:
        lodsb
        push    eax
        call    randomTable

        mov     ebx,eax
        shr     ebx,27
        shl     eax,5
        imul    ax,bx
        add     dword ptr [edi],eax
        xor     word ptr [edi],bx
        not     byte ptr [edi]

        add     edi,4
        dec     edx
        jnz     hash1
        mov     edx,8
        mov     edi,dword ptr [ebp+16]
hash1:
        loop    hash0

        popad
        pop     ebp
        retn    4*3
        
;
; DWORD randomTable(DWORD index);
;
randomTable:
        push    ebp
        mov     ebp,esp
        push    eax
        pushad

        mov     eax,dword ptr [ebp+8]
        mov     ecx,2           ; 3          | 127773
        xor     edx,edx
        div     ecx
        mov     ecx,1588635695  ; 1223106847 | 16807
        imul    ecx,edx
        mov     ebx,1117695901  ; 1117695901 | 2836
        imul    eax,ebx

        sub     ecx,eax

        mov     eax,4294967291  ; 4294967291 | 2147483647
        xor     edx,edx
        xchg    eax,ecx
        idiv    ecx

        mov     dword ptr [ebp-4],eax
        popad
        pop     eax
        pop     ebp
        retn    4

