;
; decode.asm
; Bumblebee <bbbee@mailcity.com>
;
; Description:
;
;  Little example that shows how to decode a Text Encoded plugin.
;  Notice it includes dbase64.inc instead of base64.inc. Also remember
;  to remove the rsa_e data :) (even in that example is not removed, i
;  use the same inc for both text.asm and decode.asm).
;
;  Should seem complex. It is not :D Check text.asm if you feel lost.
;
;
.486p
locals
.model flat,STDCALL

        extrn           ExitProcess:PROC
        extrn          LoadLibraryA:PROC
        extrn        GetProcAddress:PROC
        extrn           FreeLibrary:PROC
        extrn           CreateFileA:PROC
        extrn             WriteFile:PROC
        extrn              ReadFile:PROC
        extrn           GetFileSize:PROC
        extrn           CloseHandle:PROC

.DATA

; plugin name to load
plugindll       db      'decoded.dll',0
; plugin output
plugintxt       db      'plugin.txt',0

; tea key (change it each time but respect the size)
                align   4
teaCiphered     dd      BN_DWORD dup (0)
teaKey          dd      BN_DWORD dup (0)

hashRes         db      32 dup(0)

bytes           dd      0
fHnd            dd      0
dllSize         dd      0

; change those values
buffer0         dd      5*1024 dup (0)          ; to store dll plain
buffer1         dd      5*1024 dup (0)          ; to store dll encrypted
buffer2         dd      6*4*1024 dup (0)        ; to store base64 enc dll

.CODE
inicio:
                                                ; 1st get the dll
        xor     eax,eax
        push    eax
        push    00000080h
        push    3
        push    eax
        push    00000001h
        push    80000000h
        push    offset plugintxt
        call    CreateFileA
        cmp     eax,-1
        je      failedToOpen

        mov     dword ptr [fHnd],eax

        push    0h
        push    eax
        call    GetFileSize
        mov     [dllSize],eax

        xor     eax,eax
        push    eax
        push    offset bytes
        push    dword ptr [dllSize]
        push    offset buffer2
        push    dword ptr [fHnd]
        call    ReadFile

        push    dword ptr [fHnd]
        call    CloseHandle

        lea     eax,buffer2
        lea     edx,buffer1
        call    decodeBase64

        mov     [dllSize],ecx

        lea     esi,buffer1
        lea     edi,teaCiphered
        mov     ecx,BN_BYTE
        rep     movsb

        push    offset teaCiphered
        push    offset teaKey
        push    offset rsa_d
        push    offset rsa_n
        call    rsa_main                        ; deRSA TEA key :D

        sub     dword ptr [dllSize],BN_BYTE

        mov     eax,[dllSize]
        mov     ecx,8
        xor     edx,edx
        div     ecx
        or      edx,edx
        jz      greatItIsAligned
        inc     eax
greatItIsAligned:
        mul     ecx                             ; force 64 bits aligment
        mov     [dllSize],eax

        push    1
        push    dword ptr [dllSize]
        push    offset teaKey
        push    offset buffer0
        lea     esi,buffer1
        add     esi,BN_BYTE
        push    esi
        call    TEAIt                           ; deTEA all

        lea     eax,teaKey
        mov     edx,dword ptr [eax+4]
        mov     dword ptr [dllSize],edx
        mov     ecx,dword ptr [eax]

        push    edx
        push    offset buffer0
        call    CRC32                           ; check crc32
        xor     eax,ecx
        jnz     failedToOpen

        push    offset hashRes                  ; check the hash
        push    dword ptr [dllSize]
        push    offset buffer0
        call    hash

        mov     ecx,32                          ; check it's the right
        lea     edi,teaKey                      ; module
        add     edi,8
        lea     esi,hashRes                     ; check the hash
        rep     cmpsb
        jne     failedToOpen
                                                ; at this point
        xor     eax,eax                         ; save it to disk
        push    eax
        push    00000020h
        push    2
        push    eax
        push    00000001h OR 00000002h
        push    40000000h
        lea     eax,plugindll
        push    eax
        call    CreateFileA
        cmp     eax,-1
        je      failedToOpen

        mov     dword ptr [fHnd],eax

        push    0
        push    offset bytes
        push    dword ptr [dllSize]
        push    offset buffer0
        push    dword ptr [fHnd]
        call    WriteFile

        push    dword ptr [fHnd]
        call    CloseHandle

failedToOpen:
        push    0h
        call    ExitProcess

include test.inc
include ../inc/rsalib.inc
include ../inc/tealib.inc
include ../inc/crc32lib.inc
include ../inc/dbase64.inc
include ../inc/hash.inc

Ends
End     inicio


